<template>
    <v-dialog :value="value" @input="$emit('input')" scrollable max-width="500px" persistent>
        <v-card>
        <v-card-text class="pop">
            <st-title text="Datos del alumno"/>
            <st-alert
            v-if="alert.type"
            :text="alert.text"
            :type="alert.type"
            />
            <v-form
                ref="form"
                v-model="valid"
            >
                <div class="fields">
                <v-text-field
                    v-for="(field, index) in fields"
                    v-model="field.value"
                    :counter="field.counter"
                    :rules="field.rules"
                    :label="field.label"
                    :type="field.type"
                    :key="index"
                    :disabled="index !== 'correo' && !newStudent"
                    v-on:keyup.enter="index === 'correo' ? verifyEmail(field.value,field.rules) : ''"
                    required
                />
                <v-select
                    v-model="especialidad.id"
                    :items="items"
                    label="Especialidad"
                    :rules=especialidad.rules
                    item-text="nombre"
                    item-value="idUnidad"
                    required
                />
                </div>
                <div class="content-footer">
                <st-secondary-btn nombre="Cancelar" @click="$emit('input')"/>
                <st-primary-btn
                    nombre = "Registrar alumno"
                    @click="validate"
                    :disable="!valid"
                    :loading="loading"
                />
                </div>
            </v-form>
        </v-card-text>
        </v-card>
    </v-dialog>
</template>

<script>
export default {
    props:['value'],

    data(){
        return{
            items:[],
            valid: false,
            newStudent: false,
            fixedEmail: '',
            loading:false,
            alert:{
                text: '',
                type: '',
            },
            fields:{
                correo:{
                    value:'',
                    label: 'Correo electrónico',
                    counter: '',
                    rules: [
                        v => !!v || 'El e-mail es requerido',
                        v => /.+@.+\..+/.test(v) || 'El correo debe ser valido',
                    ],
                },
                codigo:{
                    value:'',
                    type: 'number',
                    label: 'Código',
                    counter: '8',
                    rules: [
                        v => !!v || 'El codigo es requerido',
                        v => (v && v.length <= 8) || 'El código debe tener menos de 8 caracteres.',
                    ],
                },
                nombres:{
                    value:'',
                    label: 'Nombres',
                    counter: '150',
                    rules: [
                        v => !!v || 'El nombre es requerido',
                        v => (v && v.length <= 150) || 'El nombre debe tener menos de 150 caracteres.',
                    ],
                },
                apellidoPat:{
                    value:'',
                    label: 'Apellido paterno',
                    counter: '150',
                    rules: [
                        v => !!v || 'El apellido materno es requerido',
                        v => (v && v.length <= 150) || 'El apellido debe tener menos de 150 caracteres.',
                    ],
                },
                apellidoMat:{
                    value:'',
                    label: 'Apellido materno',
                    counter: '150',
                    rules: [
                        v => !!v || 'El apellido materno es requerido',
                        v => (v && v.length <= 150) || 'El apellido debe tener menos de 150 caracteres.',
                    ],
                },
                telefono:{
                    value:'',
                    type: 'number',
                    label: 'Teléfono',
                    counter: '9',
                    rules: [
                        v => (v.length <= 9) || 'El teléfono debe tener menos de 9 caracteres.',
                    ],
                }
            },
            especialidad:{
                id: null,
                rules:[
                    v => !!v || 'La especialidad es requerida',
                ]
            }
        }// return

    },//acaba data

    watch:{
        'fields.correo.value'(newVal){
            if (newVal != this.fixedEmail) {
                this.cleanFields()
                this.newStudent = false
            }
        }
    },
    mounted(){
        this.getUnits()
    },

    methods:{
        cleanFields(){
            let {correo, ...fields} = this.fields
            for (let key in fields) fields[key].value = ''
        },
        async verifyEmail(email, rules){
            let boolRules = rules.map((rule) => rule(email))
            let truthyRules = boolRules.filter((bool) => bool === !!bool);
            if (boolRules.length == truthyRules.length){
                try{
                    var { data: {message, data} } = await this.$api.verifyEmail(email)
                } catch(e) {
                    this.$store.commit('setError', e)
                }
                this.alert.text = message
                if (data.usuarioExiste){
                    this.fixedEmail = data.usuario.correo
                    if(data.esAlumno){
                        //no se puede registrar
                        this.cleanFields()
                        this.newStudent = false
                        this.alert.type = "error"
                    }else{
                        //se llenan los campos
                        this.newStudent = false
                        for (let key in data.usuario) this.fields[key].value = data.usuario[key]
                        this.alert.type = "success"
                    }
                }else{
                    //se registra uno nuevo
                    this.cleanFields()
                    this.newStudent = true
                    this.alert.type = "success"
                }
            }
        },
        async getUnits(){
            try{
                // let { data : { data } } = await this.$api.getUnits()
                let { data : { data } } = await this.$api.getUnitsByUnitId(this.$store.state.role.idUnit)
                // nos estamos guiando de la api
                // http://127.0.0.1:5000/api/unidades/73d40eb8-cbb8-4650-8e69-01c30c083b32
                if (data.programas !== null){
                    data.programas.sort((a, b) => (a.nombre > b.nombre ? 1 : -1));
                    data.programas.forEach(programa => this.items.push(programa));
                }
                else
                  this.items.push(data.unidad);

            } catch (e){
                this.$store.commit('setError', e)
            }
        },
        async registerStudent(data){
            this.loading = true
            try{
                let response = await this.$api.addStudent(data)
                this.$router.push('/coordinador/alumnos')
                this.$emit('refreshData',{ response: response})
            } catch(e) {
                this.$store.commit('setError', e)
            }
            this.loading = false
        },
        validate(){
            let field = this.fields
            let data = {
                'data': {
                    'alumno': {
                        'correo':field.correo.value,
                        'codigo':field.codigo.value,
                        'nombres': field.nombres.value,
                        'apellidoPat': field.apellidoPat.value,
                        'apellidoMat': field.apellidoMat.value,
                        'telefono': field.telefono.value,
                        'idUnidad': this.especialidad.id, //definir campos obligatorios
                    }
                }
            }
            this.registerStudent(data)
        }
    }
}
</script>

<style scoped lang="scss">
</style>
